$(call onDebugMake,fichier 'configureFiles' inclu)


# ------------------------------------------------------------------------------
#                Liste des fichiers recherches automatiquement
#
# doit etre regeneree lorsque des fichiers sont ajoutes lors du developpement
# ------------------------------------------------------------------------------

# si le fichier avec la liste des fichiers a compiler n'a pas encore ete cree ou n'est pas a jour...
ifneq ($(REBUILD_FILES),)

$(call onDebugMake,REBUILD_FILES=true)
VARFILES_MULTILINES_TO_SAVE += OBJ_ALL GENERATED_FILES_ALL

# ------------------------------------------------------------------------------
# find_sourcefiles : trouver tous les fichiers a compiler
#                    ( on recherche dans la liste des dossiers recursivement
#                    tous les fichiers d'extension *.cpp *.c ... )
#
# $(1) : variable name
# $(2) : list of directory (use only '/')
# example : $(call find_sourcefiles,OBJ_COMMON,src/common)
#
# $(warning 1:$(1)   --  2:$(2) )
# $(subst /,$(SLASH),$(2))
find_sourcefiles = $(2ArgFunction)                                             \
    $(eval SOURCES_DIR:=$(2))                                                  \
    $(eval include $(MAKE_INTERN_DIR)files.mk)                                 \
    $(eval $(1):=$(OBJ))                                                       \
    $(eval $(1)_GENERATED_FILES:=$(GENERATED_FILES))                           \
    $(eval $(1)_DIR:=$(2))                                                     \
    $(eval VARFILES_MULTILINES_TO_SAVE+=$(1) $(1)_GENERATED_FILES $(1)_DIR)

find_sourcefiles_qrc = $(2ArgFunction)                                         \
    $(eval SOURCES_DIR:=$(2))                                                  \
    $(eval include $(MAKE_INTERN_DIR)filesqrc.mk)                              \
    $(eval $(1):=$(OBJ))                                                       \
    $(eval $(1)_GENERATED_FILES:=$(GENERATED_FILES))                           \
    $(eval $(1)_DIR:=$(2))                                                     \
    $(eval VARFILES_MULTILINES_TO_SAVE+=$(1) $(1)_GENERATED_FILES $(1)_DIR)




else

$(call onDebugMake,REBUILD_FILES=false)
find_sourcefiles     = $(2ArgFunction)
find_sourcefiles_qrc = $(2ArgFunction)
include $(SAVE_FILES)

endif

