$(call onDebugMake,fichier 'files' inclu)


# va chercher tous les fichiers et ecrit dans les variables FILES_XXX
include $(MAKE_INTERN_DIR)$(SYSTEM)/files.mk

# Qt files headers contains "Q_OBJECT"
FILES_QT_CPP          :=$(foreach f,$(FILES_CPP),$(if $(call find_in_files,$(f:%.cpp=%.hpp) $(f:%.cpp=%.h),Q_OBJECT),$(f)))
#FILES_CPP             :=$(filter-out $(FILES_QT_CPP),$(FILES_CPP))

#-------------------------------------------------------------------------------
#               gestion de sources des Makefiles
#-------------------------------------------------------------------------------

SRC_CPP         = $(FILES_CPP)
SRC_C           = $(FILES_C)

# Qt
SRC_QT_CPP      = $(FILES_QT_CPP)
SRC_QT_UI       = $(FILES_QT_UI:.ui=.cpp)
SRC_QT_UI_HPP   = $(FILES_QT_UI:.ui=.hpp)

SRC_QT_MOC_CPP    = $(SRC_QT_CPP:.cpp=.moc.cpp) $(SRC_QT_UI:.cpp=.moc.cpp)
SRC_CPP_ALLTYPES  = $(SRC_CPP) $(SRC_QT_UI) $(SRC_QT_MOC_CPP)
# $(SRC_QT_CPP) : on ne l'ajout pas car deja dans SRC_CPP

SRC_QT_GENERATED_FILES = $(SRC_QT_UI_HPP) $(SRC_QT_MOC_CPP)
#SRC                    = $(SRC_CPP_ALLTYPES) $(SRC_C)


#-------------------------------------------------------------------------------
# output variables
#-------------------------------------------------------------------------------

GENERATED_FILES := $(patsubst %,$(COMPIL_DIR)%,$(SRC_QT_GENERATED_FILES))

OBJ             := $(patsubst %.cpp,$(COMPIL_DIR)%$(OBJECT_EXTENSION),$(SRC_CPP_ALLTYPES)) $(patsubst %.c,$(COMPIL_DIR)%$(OBJECT_EXTENSION),$(SRC_C))


#-------------------------------------------------------------------------------
# On met toujours de cote tous les objets recuperes (ce fichier est inclu plusieurs fois)
#-------------------------------------------------------------------------------
OBJ_ALL             := $(OBJ_ALL) $(OBJ)
GENERATED_FILES_ALL := $(GENERATED_FILES_ALL) $(GENERATED_FILES)


