# risque d'etre inclu plusieurs fois alors qu'il a besoin d'etre inclu une seule fois
ifndef __RULES_FILE__
__RULES_FILE__:= 1

$(call onDebugMake,fichier 'rules' inclu (une seule fois))


#-------------------------------------------------------------------------------
#             regles de construction pour les Makefiles
# Les regles necessitant des flags sont dans rulesWithFlags
#-------------------------------------------------------------------------------

.SUFFIXES: .d $(OBJECT_EXTENSION) .moc.cpp .cpp .hpp .cxx .hxx .c .h .ui


ifndef NO_PROGRESS
PROGRESSBAR_SIZE:=$(call math,$(TERMINAL_WIDTH)-2)

# les carateres utilises pour la progress bar peuvent etre redefinis
PROGRESSBAR_L ?==
PROGRESSBAR_R ?=-

# $1 : file name to compile
# return a progressbar for this file in "progressbar"
define PROGRESSBAR
  $(eval PROGRESSBAR_SIZELEFT  :=$(call math,($(progress_$(1))*$(PROGRESSBAR_SIZE))/$(COMPIL_SIZE)))
  $(eval PROGRESSBAR_SIZERIGHT :=$(call math,$(PROGRESSBAR_SIZE)-$(PROGRESSBAR_SIZELEFT)))
  $(eval PROGRESSBAR_LEFT      :=$(call repeat_string,$(PROGRESSBAR_L),$(PROGRESSBAR_SIZELEFT)))
  $(eval PROGRESSBAR_RIGHT     :=$(call repeat_string,$(PROGRESSBAR_R),$(PROGRESSBAR_SIZERIGHT)))
	$(call echoexx,[$(PROGRESSBAR_LEFT)$(PROGRESSBAR_RIGHT)])
endef


PROGRESS_OF =$(COLORPROGRESS)[ $(progresspercent_$(1)) $(if $(DOS),%)% ]$(COLORINIT)
PROGRESS    =$(call PROGRESS_OF,$@)
ECHO_PROGRESSBAR =$(call PROGRESSBAR,$(1))

else
ECHO_PROGRESSBAR :=$(ECHOLINEXX)
endif

# Qt

$(COMPIL_DIR)%.cpp : $(COMPIL_DIR)%.hpp %.ui $(COMPIL_DIR)%.ui.h
	$(call make_directoryxx,$(@D))
	@$(call echoexx,$(PROGRESS) $(COLORTITLE)---- COMPILE $@ (hpp ui ui.h) ----$(COLORINIT))
	$(UICXX) -impl $*.hpp $*.ui -o $@
	@$(call ECHO_PROGRESSBAR,$(@))

$(COMPIL_DIR)%.hpp : %.ui $(COMPIL_DIR)%.ui.h
	$(call make_directoryxx,$(@D))
	@$(call echoexx,$(PROGRESS) $(COLORTITLE)---- COMPILE $@ (ui ui.h) ----$(COLORINIT))
	$(UICXX) $< -o $@
	@$(call ECHO_PROGRESSBAR,$(@))

$(COMPIL_DIR)%.cpp : %.ui $(COMPIL_DIR)%.hpp
	$(call make_directoryxx,$(@D))
	@$(call echoexx,$(PROGRESS) $(COLORTITLE)---- COMPILE $@ (hpp ui) ----$(COLORINIT))
	$(UICXX) $< -o $@
	@$(call ECHO_PROGRESSBAR,$(@))

$(COMPIL_DIR)%.hpp : %.ui
	$(call make_directoryxx,$(@D))
	@$(call echoexx,$(PROGRESS) $(COLORTITLE)---- COMPILE $@ (ui) ----$(COLORINIT))
	$(UICXX) $< -o $@
	@$(call ECHO_PROGRESSBAR,$(@))


$(COMPIL_DIR)%.moc.cpp : $(COMPIL_DIR)%.hpp %.ui $(COMPIL_DIR)%.ui.h
	$(call make_directoryxx,$(@D))
	@$(call echoexx,$(PROGRESS) $(COLORTITLE)---- COMPILE $@ (hpp ui ui.h) ----$(COLORINIT))
	$(MOCXX) $< -o $@
	@$(call ECHO_PROGRESSBAR,$(@))

$(COMPIL_DIR)%.moc.cpp : $(COMPIL_DIR)%.hpp %.ui
	$(call make_directoryxx,$(@D))
	@$(call echoexx,$(PROGRESS) $(COLORTITLE)---- COMPILE $@ (hpp ui) ----$(COLORINIT))
	$(MOCXX) $< -o $@
	@$(call ECHO_PROGRESSBAR,$(@))

$(COMPIL_DIR)%.moc.cpp : %.hpp %.cpp
	$(call make_directoryxx,$(@D))
	@$(call echoexx,$(PROGRESS) $(COLORTITLE)---- COMPILE $@ (hpp cpp) ----$(COLORINIT))
	$(MOCXX) $< -o $@
	@$(call ECHO_PROGRESSBAR,$(@))

$(COMPIL_DIR)%.moc.cpp : %.hpp
	$(call make_directoryxx,$(@D))
	@$(call echoexx,$(PROGRESS) $(COLORTITLE)---- COMPILE $@ (hpp) ----$(COLORINIT))
	$(MOCXX) $< -o $@
	@$(call ECHO_PROGRESSBAR,$(@))


# QRC

$(COMPIL_DIR)%.cpp : %.qrc
	$(call make_directoryxx,$(@D))
	@$(call echoexx,$(PROGRESS) $(COLORTITLE)---- COMPILE $@ (qrc) ----$(COLORINIT))
	$(RCCXX)  -name $(*D)/$(*F) $< -o $@
	@$(call ECHO_PROGRESSBAR,$(@))



endif

