# risque d'etre inclu plusieurs fois alors qu'il a besoin d'etre inclu une seule fois
ifndef __RULESWITHFLAGS_FILE__
__RULESWITHFLAGS_FILE__:= 1

$(call onDebugMake,fichier 'rulesWithFlags' inclu)

#-------------------------------------------------------------------------------
# Les regles de construction necessitant des flags
# Les regles completement generiques sont dans le fichier "rules"
#-------------------------------------------------------------------------------

# creer le fichier de dependance de la cible courante
# TODO : the dependance may need $(RULES_FLAGS), for all include files flags...
#        but the $(RULES_FLAGS) can be in windows compilator format !
ifndef NO_DEPEND
define MAKE_DEPEND
	@$(call echoexx,$$(call PROGRESS_OF,$$(@:$$(OBJECT_EXTENSION)=.d)) $(COLORTITLE)---- DEPENDANCIES $$(@:$(OBJECT_EXTENSION)=.d) ----$(COLORINIT))
	$(DEPENDXX) $(if $(RULES_COMPIL_DIR),$(DEPENDXX_FLAG_INCLUDE_DIRECTORY)$$(@D)) $(DEPENDXX_RULES_INCLUDE) "$$<" -MF "$$(@:$(OBJECT_EXTENSION)=.d)" -MT "$$@"
	@$$(call ECHO_PROGRESSBAR,$$(@:$(OBJECT_EXTENSION)=.d))
endef
else
MAKE_DEPEND =
endif


RULES_COMPILATION_CCXX  =$(CCXX) $(RULES_FLAGS) $(if $(RULES_COMPIL_DIR),$(CXX_FLAG_INCLUDE_DIRECTORY)$$(@D)) $(RULES_INCLUDE) $(CXX_FLAG_CPP_FILES)"$$<" $(CXX_FLAG_OBJECT_OUTPUT)"$$@"

RULES_COMPILATION_CXX  =$(CXX) $(RULES_FLAGS) $(if $(RULES_COMPIL_DIR),$(CXX_FLAG_INCLUDE_DIRECTORY)$$(@D)) $(RULES_INCLUDE) $(CXX_FLAG_C_FILES)"$$<" $(CXX_FLAG_OBJECT_OUTPUT)"$$@"


#
# private_rules_with_specific_flags
#
# $1 : RULES_FLAGS
# $2 : RULES_INCLUDEPATH
# $3 : RULES_COMPIL_DIR
# $4 : RULES_DIR
#
define private_rules_with_specific_flags

$(eval RULES_FLAGS:=$(1))
$(eval RULES_COMPIL_DIR:=$(3))
$(eval RULES_DIR:=$(4))
$(eval RULES_INCLUDEPATH:=$(2) $(if $(RULES_COMPIL_DIR),$(foreach i,$(2),$(RULES_COMPIL_DIR)$(i))) $(RULES_COMPIL_DIR)$(RULES_DIR))
$(eval RULES_INCLUDE:=$(subst $(SPACE_FAKE),$(SPACE),$(RULES_INCLUDEPATH:%=$(CXX_FLAG_INCLUDE_DIRECTORY)"%")))
$(eval DEPENDXX_RULES_INCLUDE:=$(subst $(SPACE_FAKE),$(SPACE),$(RULES_INCLUDEPATH:%=$(DEPENDXX_FLAG_INCLUDE_DIRECTORY)"%")))

# Qt

$(RULES_COMPIL_DIR)$(RULES_DIR)%.moc$(OBJECT_EXTENSION) : $(RULES_COMPIL_DIR)$(RULES_DIR)%.moc.cpp
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (moc.cpp) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

# C++

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.cpp $(RULES_DIR)%.hpp $(RULES_DIR)%.inl
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (cpp hpp inl) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.cpp $(RULES_DIR)%.hpp $(RULES_DIR)%.inc
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (cpp hpp inc) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.cpp $(RULES_DIR)%.hpp
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (cpp hpp) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.cpp $(RULES_DIR)%.cpp.hpp
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (cpp hpp) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.cpp $(RULES_DIR)%.cpp.h
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (cpp h) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.cpp $(RULES_DIR)%.h
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (cpp h) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.cpp
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (cpp) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.cc $(RULES_DIR)%.hh
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (cc hh) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.cc
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (cc) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.cxx $(RULES_DIR)%.hxx
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (cxx hxx) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.cxx
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (cxx) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))


$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.C $(RULES_DIR)%.H
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (C H) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))


$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.C
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (C) ----$(COLORINIT))
	$(RULES_COMPILATION_CCXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))


#C

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.c $(RULES_DIR)%.h
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (c h) ----$(COLORINIT))
	$(RULES_COMPILATION_CXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

$(RULES_COMPIL_DIR)$(RULES_DIR)%$(OBJECT_EXTENSION) : $(RULES_DIR)%.c
	$(call make_directoryxx,$$(@D))
	$(MAKE_DEPEND)
	@$(call echoexx,$$(PROGRESS) $(COLORTITLE)---- COMPILE $$@ (c) ----$(COLORINIT))
	$(RULES_COMPILATION_CXX)
	@$$(call ECHO_PROGRESSBAR,$$(@))

endef


endif


