$(call onDebugMake,_____BEGIN_____)
$(call onDebugMake,fichier 'begin' inclu)


BUILD_INTERN_DIR :=$(TOPDIR)makeCfiles/
MAKE_INTERN_DIR  :=$(BUILD_INTERN_DIR)make/


#-------------------------------------------------------------------------------
# en cas de probleme DEBUGUAGE DU MAKEFILE avec l'option "debugmake=1"
#-------------------------------------------------------------------------------
include $(MAKE_INTERN_DIR)debugMake.mk

#-------------------------------------------------------------------------------
# teste le probleme des espaces...
#-------------------------------------------------------------------------------
ifneq ($(words $(CURDIR)),1)
$(error You must not have whitespace in the path ($(CURDIR)))
endif
ifneq ($(words $(TOPDIR)),1)
ifneq ($(words $(TOPDIR)),0)
$(error You must not have whitespace in the path ($(TOPDIR)))
endif
endif


#-------------------------------------------------------------------------------
# definit le SYSTEME D'EXPLOITATION
#-------------------------------------------------------------------------------
include $(MAKE_INTERN_DIR)systemDetection.mk

#-------------------------------------------------------------------------------
# vous pouvez redefinir un repertoire particulier ou trouver une librairie
#-------------------------------------------------------------------------------
include $(BUILD_INTERN_DIR)yourconfiguration.mk

#-------------------------------------------------------------------------------
# definit le compilateur a utiliser
#-------------------------------------------------------------------------------
ifdef WINDOWS
  COMPILATOR ?=visualc
else
  COMPILATOR ?=gcc
endif
include $(MAKE_INTERN_DIR)compilator/$(COMPILATOR).mk

#-------------------------------------------------------------------------------
# definit les adresses des LIBRAIRIES a inclure et
# COMMANDES makefile utiles
#-------------------------------------------------------------------------------
include $(MAKE_INTERN_DIR)config.mk



#-------------------------------------------------------------------------------
# determine si on compile ou si on execute une commande
#-------------------------------------------------------------------------------
# liste de toutes les commandes independantes de la config, de la liste de fichiers, etc.
INDEPENDENT_COMMANDS := configure clean bigclean ultraclean clear b B doxygen cleandoxygen c release save saveToFtp savecode help h

ifneq ($(filter $(INDEPENDENT_COMMANDS),$(MAKECMDGOALS)),)
  INDEPENDENT_COMMANDS_GOAL:=1
  $(call onDebugMake,INDEPENDENT_COMMANDS_GOAL:=1)
endif


ifndef INDEPENDENT_COMMANDS_GOAL

#-------------------------------------------------------------------------------
# FILES et LIBS AUTO
#-------------------------------------------------------------------------------
include $(MAKE_INTERN_DIR)configureAuto.mk

#-------------------------------------------------------------------------------
# FONCTIONS pour creer les regles de compilation pour les objets,
# les executables ou les librairies
#-------------------------------------------------------------------------------
include $(MAKE_INTERN_DIR)create.mk


#-------------------------------------------------------------------------------

BUILD_BEGIN := $(SAVE_CONFIG) $(SAVE_FILES) affBegin
BUILD_END   := affEnd

.DEFAULT :: all
# quand il n'y a pas d'argument au make, par defaut on compile l'executable
all :: $(BUILD_BEGIN) $(COMPILATION) $(BUILD_END) ;

endif



#-------------------------------------------------------------------------------
# Pour la mise en page...
#-------------------------------------------------------------------------------
ifeq ($(call exist,$(BUILD_INTERN_DIR)yourlogo.mk),)
  include $(MAKE_INTERN_DIR)logo.mk
else
  include $(BUILD_INTERN_DIR)yourlogo.mk
endif
