$(call onDebugMake,fichier 'config' inclu)

#-------------------------------------------------------------------------------
# File :
#             fichier contenant les elements de bases
#-------------------------------------------------------------------------------
# ce fichier contient :
# 1. detections des arguments du make
# 2. variables et fonctions de bases
# 3. inclu le fichier "$(SYSTEM)/config" contenant les elements
#    specifiques au systeme d'exploitation
#-------------------------------------------------------------------------------

COMPIL_DIR ?=.compil/

ROOT_COMPIL_DIR :=$(COMPIL_DIR)
COMPIL_DIR:=$(COMPIL_DIR)$(SYSTEM)/



# mode debug or release
ifdef release
$(call onDebugMake,mode release)
	DEBUG:=
	COMPIL_DIR:=$(COMPIL_DIR)release/
else
$(call onDebugMake,mode debug)
	DEBUG:= 1
	COMPIL_DIR:=$(COMPIL_DIR)debug/
endif


ifneq (,$(findstring configure,$(MAKECMDGOALS)))
$(call onDebugMake,mode configure)
	CONFIGURE:= 1
else
	CONFIGURE:=
endif



COMMA:=,

EMPTY:=

# This results in SPACE containing just a space
SPACE :=
SPACE +=

SPACE_FAKE:=_SPACE_

# Standard definitions for true and false.  true is any non-empty
# string, false is an empty string. These are intended for use with
# $(if).
TRUE  := 1
FALSE :=

#-------------------------------------------------------------------------------
# Function:  not
# Arguments: 1: A boolean value
# Returns:   Returns the opposite of the arg. (true -> false, false -> true)
#-------------------------------------------------------------------------------
not = $(if $1,$(FALSE),$(TRUE))


#-------------------------------------------------------------------------------
# Function:  exist
# Arguments: 1: files or directory
# Returns:   Returns the list of existing arguments
#-------------------------------------------------------------------------------
exist=$(wildcard $(subst $(SPACE_FAKE),\$(SPACE),$(1)))


# pas teste
# exemple : $(call rwildcard,a/b,*.c)
# rwildcard = $(foreach d,$(wildcard $1*),$(call rwildcard,$d/)$(filter $(subst *,%,$2),$d))

MAKEXX := make
MAKESILENTXX := make --no-print-directory -s

include $(MAKE_INTERN_DIR)$(SYSTEM)/config.mk

# $1 : file name
# $2 : string to write in the file
define write_in_file

	$(call echoxx,$(2))>> "$(call convert_slash_to_system,$1)"

endef


# $1 : file name
# $2 : variable name
define write_var_in_file

	$(call echoxx,$(2):=$($(2))) >> "$(call convert_slash_to_system,$1)"

endef

# $1 : file name
# $2 : variable name
#write_var_in_file =$(call echoxx,$(1):=$($(1))) >> "$(call convert_slash_to_system,$2)"
define write_var_multilines_in_file
	$(call write_in_file,$(1),$(2):=$(NO_END_LINE))
	$(foreach i,$($(2)),$(call write_in_file,$(1),    $(i) $(NO_END_LINE)))
	@$(ECHONEWLINEXX)>> "$(call convert_slash_to_system,$1)"
endef



# @$(ECHONEWLINEXX) >> $2
# @$(ECHONEWLINEXX) >> $2

# define LINE variable as _____________________ with terminal width
LINE:=$(call repeat_string,_,$(TERMINAL_WIDTH))

ECHOLINEXX :=$(call echoxx,$(LINE))

